#include <p18cxxx.h>
#include <string.h>
#include <tcpip stack/tcpip.h>


#pragma config WDT=OFF, FOSC2=ON, FOSC=HSPLL, ETHLED=ON, XINST=ON

#define THIS_IS_STACK_APPLICATION //So stack knows AppConfig is in this file
APP_CONFIG AppConfig;
static void InitAppConfig(void);
	
#pragma interruptlow LowISR
void LowISR(void)
{
	TickUpdate(); //Needed for network stack timing
}


#pragma interrupt HighISR
void HighISR(void)
{

}

#pragma code lowVector=0x18
void LowVector(void){_asm goto LowISR _endasm}
#pragma code highVector=0x8
void HighVector(void){_asm goto HighISR _endasm}
#pragma code

void main(void)
{
	static DWORD t = 0;

	//HARDWARE
	OSCTUNE = 0x40; //42MHz from 25MHz clock
	RCONbits.IPEN=1;
	INTCONbits.GIEH = 1;
    INTCONbits.GIEL = 1;
	
	//Turn on LED
	TRISBbits.TRISB4 = 0;

	//TCP IP STACK
 	TickInit();
	InitAppConfig();
	StackInit();

	//MAIN LOOP
	while(1)
	{

  		if(TickGet() - t >= TICK_SECOND/2ul) //Blink LED
        {
            t = TickGet();
            PORTBbits.RB4 ^= 1;
        }
		StackTask();
		StackApplications();
	}
}



static void InitAppConfig(void)
{
	//Set up network stack parameters
	static ROM BYTE SerializedMACAddress[6] = {0x00, 0x04, 0xA4, 0x00, 0x00, 0x00};
	memset((void*)&AppConfig, 0x00, sizeof(AppConfig));	
	AppConfig.Flags.bIsDHCPEnabled = TRUE;
	memcpypgm2ram((void*)&AppConfig.MyMACAddr, (ROM void*)SerializedMACAddress, sizeof(AppConfig.MyMACAddr));
}